<?php
	/*	
	*	Goodlayers Framework File
	*	---------------------------------------------------------------------
	*	This file contains the homepage loading button in page option area
	*	---------------------------------------------------------------------
	*/
	
	add_action('add_meta_boxes', 'limoking_init_demo_page_option');
	if( !function_exists('limoking_init_demo_page_option') ){
		function limoking_init_demo_page_option(){
			add_meta_box( 'demo-page-option', 
				esc_html__('Load Demo Page', 'limoking'), 
				'limoking_create_demo_page_option',
				'page',
				'side',
				'default'
			);
		}
	}
	
	if( !function_exists('limoking_create_demo_page_option') ){
		function limoking_create_demo_page_option(){
			global $post;
		
			$buttons = array(
				'homepage-1' => esc_html__('Homepage', 'limoking'),
				'about-1' => esc_html__('About Us 1', 'limoking'),
				'about-2' => esc_html__('About Us 2', 'limoking'),
				'service-1' => esc_html__('Service 1', 'limoking'),
				'contact-1' => esc_html__('Contact 1', 'limoking'),
				'contact-2' => esc_html__('Contact 2', 'limoking'),
				'faq' => esc_html__('FAQ', 'limoking'),
				'service-rates' => esc_html__('Service Rates', 'limoking'),
			);
			
			echo '<div id="limoking-load-demo-wrapper" data-ajax="' . esc_url(AJAX_URL) . '" data-id="' . $post->ID . '" data-action="load_demo_pagebuilder">';
			echo '<em>';
			echo esc_html__('*This option allow you to set page item to following pages with one click. Note that to use this option will replace all your current page item setting in this page and <strong>This Can\'t Be Undone</strong>. ( Images are not included. )', 'limoking');
			echo '</em><div class="clear"></div>';
			echo '<select name="limoking-load-demo-page" >';
			foreach( $buttons as $button_slug => $button_title ){
				echo '<option type="button"  value="' . $button_slug . '" >' . $button_title . '</option>';
			}
			echo '</select>';
			echo '<input type="button" value="' . esc_html__('Submit', 'limoking') . '" />';
			echo '</div>';

		}
	}
	
	add_action('wp_ajax_load_demo_pagebuilder', 'limoking_load_demo_pagebuilder');
	if( !function_exists('limoking_load_demo_pagebuilder') ){
		function limoking_load_demo_pagebuilder(){
			$default_data = array(
				'homepage-1' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[]',
					'content-with-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Full Size Wrapper","type":"full-size-wrapper","items":[{"item-type":"item","item-builder-title":"Master Slider","type":"master-slider","option":{"page-item-id":"","id":"1","margin-bottom":"0px"}}],"option":{"page-item-id":"","skin":"no-skin","background":"#ffffff","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"0px","padding-bottom":"0px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"item","item-builder-title":"Title","type":"title","option":{"page-item-id":"","title-type":"center-icon-divider","title-size":"large","title":"We serve you like a king","caption":"We offer you a super VIP experience in middle of New York.","title-icon-class":"fa-star","right-text":"Read All News","right-text-link":"","margin-bottom":"20px"}}],"option":{"page-item-id":"","type":"image","background":"5970","background-mobile":"","background-speed":"0","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"limoking-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"72px","padding-bottom":"430px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Car","type":"car","option":{"page-item-id":"","title-type":"center-icon-divider","title-size":"medium","title":"Our Fleet","caption":"","title-icon-class":"fa-car","right-text":"Read All News","right-text-link":"","category":"","tag":"","car-style":"modern-car","car-price-display":"none","num-fetch":"9","car-size":"1/3","car-layout":"carousel","car-filter":"enable","thumbnail-size":"full","thumbnail-size-featured":"thumbnail","orderby":"date","order":"desc","pagination":"disable","margin-bottom":"0px"}}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"0px","padding-bottom":"10px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"About Us","type":"about-us","option":{"page-item-id":"","style":"with-divider","title":"We promise, you will have  the best experience","caption":"","content":"<p>Sed posuere consectetur est at lobortis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nullam quis risus eget urna mollis ornare vel eu leo. Cras mattis consectetur purus sit amet fermentum.</p>","read-more-type":"","read-more-text":"Book Now","read-more-link":"#","margin-bottom":"20px"}}],"option":{},"size":"1/2"}],"option":{"page-item-id":"","type":"image","background":"5768","background-mobile":"","background-speed":"0","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"limoking-skin-darkblue","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"95px","padding-bottom":"50px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Stunning Text","type":"stunning-text","option":{"page-item-id":"","title":"What about pricing?","caption":"Don’t worry. We provide very nice deals and the most competative price just for you!","read-more-type":"","button-text":"Check Rates","button-link":"http://demo.goodlayers.com/limoking/service-rates/","button-text-color":"#fff","button-background":"#009fbd","margin-bottom":"0"}}],"option":{"page-item-id":"","background-type":"color","background":"#1eacc7","skin":"limoking-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"0px","padding-bottom":"0px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"item","item-builder-title":"Title","type":"title","option":{"page-item-id":"","title-type":"center-divider","title-size":"medium","title":"Our Services","caption":"Magna Risus Vestibulum Vulputate","title-icon-class":"","right-text":"Read All News","right-text-link":"","margin-bottom":"20px"}}],"option":{"page-item-id":"","type":"image","background":"5984","background-mobile":"","background-speed":"0","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"limoking-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"70px","padding-bottom":"40px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","size":"medium","image":"5876","icon":"","caption":"","title":"Night Parties","content":"<p>Limos King offers superb lim service in New York and Manhatatan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc.</p>","read-more-text":"Read More","read-more-link":"#","margin-bottom":"40px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","size":"medium","image":"5877","icon":"","caption":"","title":"Weddings","content":"<p>Limos King offers superb lim service in New York and Manhatatan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc.</p>","read-more-text":"Read More","read-more-link":"#","margin-bottom":"40px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","size":"medium","image":"5878","icon":"","caption":"","title":"Casinos","content":"<p>Limos King offers superb lim service in New York and Manhatatan. We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc.</p>","read-more-text":"Read More","read-more-link":"#","margin-bottom":"40px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","size":"medium","image":"5879","icon":"","caption":"","title":"Birthdays","content":"<p>Limos King offers superb lim service in New York and Manhatatan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc.</p>","read-more-text":"Read More","read-more-link":"#","margin-bottom":"40px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","size":"medium","image":"5880","icon":"","caption":"","title":"Proms","content":"<p>Limos King offers superb lim service in New York and Manhatatan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc.</p>","read-more-text":"Read More","read-more-link":"#","margin-bottom":"40px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","size":"medium","image":"5881","icon":"","caption":"","title":"Airport Transfers","content":"<p>Limos King offers superb lim service in New York and Manhatatan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc.</p>","read-more-text":"Read More","read-more-link":"#","margin-bottom":"40px"}}],"option":{},"size":"1/3"}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"70px","padding-bottom":"20px"}},{"item-type":"wrapper","item-builder-title":"Full Size Wrapper","type":"full-size-wrapper","items":[{"item-type":"item","item-builder-title":"Master Slider","type":"master-slider","option":{"page-item-id":"","id":"2","margin-bottom":"0px"}}],"option":{"page-item-id":"","skin":"no-skin","background":"#ffffff","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"0px","padding-bottom":"0px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"left","title-size":"small","title":"Video Tour","caption":"","title-icon-class":"","right-text":"Read All News","right-text-link":"","content":"","margin-bottom":"0px"}},{"item-type":"item","item-builder-title":"Video","type":"video","option":{"page-item-id":"","url":"https://vimeo.com/45345886","margin-bottom":"20px"}},{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title-size":"medium","title":"","caption":"","title-icon-class":"","right-text":"Read All News","right-text-link":"","content":"<p><strong><span style=|gq2|color: #1eacc7;|gq2|>Watch our fleet in this video</span></strong></p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Testimonial","type":"testimonial","option":{"page-item-id":"","testimonial":"[{|gq2|gdl-tab-author-image-url|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/testimonial-s-1.jpg|gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2|5993|gq2|,|gq2|gdl-tab-title|gq2|:|gq2|John Doe|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|General Manager, Coca Co.|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Cras justo odio, dapibus ac facilisis in, egestas eget quam. Curabit,ur blandit tempus porttitor. Praesent commodo cursus magna.|gq2|},{|gq2|gdl-tab-author-image-url|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/testimonial-s-2.jpg|gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2|5994|gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Sam Smith|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|CEO, The Klise|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Cras justo odio, dapibus ac facilisis in, egestas eget quam. Curabit,ur blandit tempus porttitor. Praesent commodo cursus magna.|gq2|}]","title-type":"left","title-size":"small","title":"Testimonial","caption":"","title-icon-class":"","testimonial-columns":"1","testimonial-type":"carousel","testimonial-style":"modern-style","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Blog","type":"blog","option":{"page-item-id":"","title-type":"left","title-size":"small","title":"Recent News","caption":"","title-icon-class":"","right-text":"Read All News","right-text-link":"http://demo.goodlayers.com/limoking/blog-full-with-right-sidebar/","category":"","tag":"","num-excerpt":"25","num-fetch":"3","blog-style":"blog-widget-1-1","blog-layout":"fitRows","thumbnail-size":"round-personnel-size","orderby":"date","order":"desc","offset":"","pagination":"disable","enable-sticky":"disable","margin-bottom":"0px"}}],"option":{},"size":"1/3"}],"option":{"page-item-id":"","background-type":"","background":"#ffffff","skin":"","show-section":"","border":"","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"60px","padding-bottom":"40px"}}]',
					'post-option'=>'{"sidebar":"no-sidebar","left-sidebar":"Footer 1","right-sidebar":"Footer 1","page-style":"normal","show-title":"disable","page-caption":"","show-content":"enable","header-background":""}'
				),
				'about-1' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[]',
					'content-with-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"item","item-builder-title":"Title","type":"title","option":{"page-item-id":"","title-type":"center-icon-divider","title-size":"large","title":"About Limo King","caption":"We are the most popular limousine service in New York.","title-icon-class":"fa-star","right-text":"Read All News","right-text-link":"","margin-bottom":"20px"}}],"option":{"page-item-id":"","type":"image","background":"5814","background-mobile":"","background-speed":"0","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"limoking-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"150px","padding-bottom":"70px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Image / Frame","type":"image-frame","option":{"page-item-id":"","image-id":"5819","thumbnail-size":"full","link-type":"none","title":"","content":"","url":"","frame-type":"none","frame-background":"#dddddd","margin-bottom":"20px"}}],"option":{},"size":"1/2"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"About Us","type":"about-us","option":{"page-item-id":"","style":"plain","title":"Ullamcorper Parturient Vulputate  Ultricies Malesuada","caption":"","content":"<p>Limos King offers superb lim service in New York and Manhatatan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc. Donec id elit non mi porta gravida at eget metus. Cras justo odio, dapibus ac facilisis in, egestas eget quam. Aenean lacinia bibendum nulla sed consectetur. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus.  Donec ullamcorper nulla non metus auctor fringilla. Donec ullamcorper nulla non metus auctor fringilla. Praesent commodo cursus magna, vel scelerisque nisl consectetur et.</p>","read-more-type":"","read-more-text":"Read More","read-more-link":"","margin-bottom":"20px"}}],"option":{},"size":"1/2"}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"70px","padding-bottom":"30px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-4","items":[{"item-type":"item","item-builder-title":"Skill Item","type":"skill-item","option":{"page-item-id":"","style":"style-1","icon-color":"#ffffff","title-color":"#ffffff","caption-color":"#ffffff","icon-class":"","title":"9000","caption":"HAPPY CUSTOMERS","margin-bottom":"20px"}}],"option":{},"size":"1/4"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-4","items":[{"item-type":"item","item-builder-title":"Skill Item","type":"skill-item","option":{"page-item-id":"","style":"style-1","icon-color":"#ffffff","title-color":"#ffffff","caption-color":"#ffffff","icon-class":"","title":"12","caption":"LUXURY LIMOS","margin-bottom":"20px"}}],"option":{},"size":"1/4"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-4","items":[{"item-type":"item","item-builder-title":"Skill Item","type":"skill-item","option":{"page-item-id":"","style":"style-1","icon-color":"#ffffff","title-color":"#ffffff","caption-color":"#ffffff","icon-class":"","title":"900000","caption":"MILES","margin-bottom":"20px"}}],"option":{},"size":"1/4"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-4","items":[{"item-type":"item","item-builder-title":"Skill Item","type":"skill-item","option":{"page-item-id":"","style":"style-1","icon-color":"#ffffff","title-color":"#ffffff","caption-color":"#ffffff","icon-class":"","title":"30","caption":"QUALIFIED CHAUFFUERS","margin-bottom":"20px"}}],"option":{},"size":"1/4"}],"option":{"page-item-id":"","type":"image","background":"5821","background-mobile":"","background-speed":"0.1","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"limoking-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"95px","padding-bottom":"65px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"About Us","type":"about-us","option":{"page-item-id":"","style":"with-divider","title":"Only Qualified Chauffeurs","caption":"","content":"<p>Sed posuere consectetur est at lobortis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nullam quis risus eget urna mollis ornare vel eu leo. Cras mattis consectetur purus sit amet fermentum.</p>","read-more-type":"car-form","read-more-text":"Book Now","read-more-link":"#","margin-bottom":"20px"}}],"option":{},"size":"3/5"}],"option":{"page-item-id":"","type":"image","background":"5824","background-mobile":"","background-speed":"0","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"limoking-skin-about-us","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"100px","padding-bottom":"60px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"no-media","size":"medium","image":"","icon":"","caption":"Venenatis Fusce Vulputate","title":"Fermentum Risus Venetnatis","content":"<p>Limos King offers superb lim service in New York and Manhatatan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc. Donec id elit non mi.</p>","read-more-text":"Read More","read-more-link":"","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"no-media","size":"medium","image":"","icon":"","caption":"Justo Consectetur Fermentum","title":"Cursus Euismod Tortor","content":"<p>Limos King offers superb lim service in New York and Manhatatan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc. Donec id elit non mi.</p>","read-more-text":"Read More","read-more-link":"","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"no-media","size":"medium","image":"","icon":"","caption":"Purus Mollis Ornare","title":"Dolor Fusce Fringilla","content":"<p>Limos King offers superb lim service in New York and Manhatatan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc. Donec id elit non mi.</p>","read-more-text":"Read More","read-more-link":"","margin-bottom":"20px"}}],"option":{},"size":"1/3"}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"55px","padding-bottom":"10px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Stunning Text","type":"stunning-text","option":{"page-item-id":"","title":"What about pricing?","caption":"Don’t worry. We provide very nice deals and the most competative price just for you!","read-more-type":"url","button-text":"Check Rates","button-link":"http://demo.goodlayers.com/limoking/service-rates/","button-text-color":"#fff","button-background":"#009fbd","margin-bottom":"0"}}],"option":{"page-item-id":"","background-type":"color","background":"#1eacc7","skin":"limoking-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"0px","padding-bottom":"0px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Personnel","type":"personnel","option":{"page-item-id":"","personnel":"[{|gq2|gdl-tab-author-image-url|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/personnel-1.jpg|gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2|5834|gq2|,|gq2|gdl-tab-title|gq2|:|gq2|John Smith|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|CEO & Founder|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Vestibulum id ligula porta felis euismod semper. Cum sociis natoque penatibus et magnis dis parturient mo ntes, nascetur ridiculus mus. |gq2|,|gq2|gdl-tab-social-list|gq2|:|gq2|[gdlr_icon type=|gq6|fa-facebook|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  [gdlr_icon type=|gq6|fa-twitter|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  [gdlr_icon type=|gq6|fa-linkedin|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  [gdlr_icon type=|gq6|fa-skype|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  [gdlr_icon type=|gq6|fa-pinterest|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  |gq2|},{|gq2|gdl-tab-author-image-url|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/personnel-2.jpg|gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2|5835|gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Peter Johnson|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|CFO|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Vestibulum id ligula porta felis euismod semper. Cum sociis natoque penatibus et magnis dis parturient mo ntes, nascetur ridiculus mus. |gq2|,|gq2|gdl-tab-social-list|gq2|:|gq2|[gdlr_icon type=|gq6|fa-facebook|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  [gdlr_icon type=|gq6|fa-twitter|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  [gdlr_icon type=|gq6|fa-linkedin|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  [gdlr_icon type=|gq6|fa-skype|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  [gdlr_icon type=|gq6|fa-pinterest|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  |gq2|},{|gq2|gdl-tab-author-image-url|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/personnel-3.jpg|gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2|5836|gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Paul Dowson|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Chauffeur Trainer|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Vestibulum id ligula porta felis euismod semper. Cum sociis natoque penatibus et magnis dis parturient mo ntes, nascetur ridiculus mus. |gq2|,|gq2|gdl-tab-social-list|gq2|:|gq2|[gdlr_icon type=|gq6|fa-facebook|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  [gdlr_icon type=|gq6|fa-twitter|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  [gdlr_icon type=|gq6|fa-linkedin|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  [gdlr_icon type=|gq6|fa-skype|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  [gdlr_icon type=|gq6|fa-pinterest|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  |gq2|},{|gq2|gdl-tab-author-image-url|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/personnel-4.jpg|gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2|5837|gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Jane Coles|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Human Relation|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Vestibulum id ligula porta felis euismod semper. Cum sociis natoque penatibus et magnis dis parturient mo ntes, nascetur ridiculus mus. |gq2|,|gq2|gdl-tab-social-list|gq2|:|gq2|[gdlr_icon type=|gq6|fa-facebook|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  [gdlr_icon type=|gq6|fa-twitter|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  [gdlr_icon type=|gq6|fa-linkedin|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  [gdlr_icon type=|gq6|fa-skype|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  [gdlr_icon type=|gq6|fa-pinterest|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  |gq2|},{|gq2|gdl-tab-author-image-url|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/personnel-5.jpg|gq2|,|gq2|gdl-tab-author-image|gq2|:|gq2|5838|gq2|,|gq2|gdl-tab-title|gq2|:|gq2|Sam Smith|gq2|,|gq2|gdl-tab-position|gq2|:|gq2|Accountant|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Vestibulum id ligula porta felis euismod semper. Cum sociis natoque penatibus et magnis dis parturient mo ntes, nascetur ridiculus mus. |gq2|,|gq2|gdl-tab-social-list|gq2|:|gq2|[gdlr_icon type=|gq6|fa-facebook|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  [gdlr_icon type=|gq6|fa-twitter|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  [gdlr_icon type=|gq6|fa-linkedin|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  [gdlr_icon type=|gq6|fa-skype|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  [gdlr_icon type=|gq6|fa-pinterest|gq6| size=|gq6|18px|gq6| color=|gq6|#444444|gq6| link=|gq6|#|gq6| ]  |gq2|}]","title-type":"left-divider","title-size":"medium","title":"Meet The Team","caption":"","title-icon-class":"","personnel-columns":"4","personnel-type":"carousel","personnel-style":"modern-style","thumbnail-size":"full","margin-bottom":"20px"}}],"option":{"page-item-id":"","background-type":"","background":"#ffffff","skin":"","show-section":"","border":"","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"60px","padding-bottom":"40px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Banner","type":"banner","option":{"page-item-id":"","slider":"[[5859,5860,5861,5862,5863],{|gq2|5847|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/banner-1-150x100.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:100},|gq2|5848|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/banner-2-150x100.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:100},|gq2|5849|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/banner-3-150x100.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:100},|gq2|5850|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/banner-4-150x100.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:100},|gq2|5851|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/banner-5-150x100.jpg|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:100},|gq2|5853|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/banner-1-150x100.png|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:100},|gq2|5854|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/banner-2-150x100.png|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:100},|gq2|5855|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/banner-3-150x100.png|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:100},|gq2|5856|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/banner-4-150x100.png|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:100},|gq2|5857|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/banner-5-150x100.png|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:100},|gq2|5859|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/banner-1-150x100.png|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:100},|gq2|5860|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/banner-2-150x100.png|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:100},|gq2|5861|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/banner-3-150x100.png|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:100},|gq2|5862|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/banner-4-150x100.png|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:100},|gq2|5863|gq2|:{|gq2|title|gq2|:|gq2||gq2|,|gq2|caption|gq2|:|gq2||gq2|,|gq2|caption-position|gq2|:|gq2||gq2|,|gq2|slide-link|gq2|:|gq2||gq2|,|gq2|url|gq2|:|gq2||gq2|,|gq2|new-tab|gq2|:|gq2|enable|gq2|,|gq2|thumbnail|gq2|:|gq2|http://demo.goodlayers.com/limoking/wp-content/uploads/2015/11/banner-5-150x100.png|gq2|,|gq2|width|gq2|:150,|gq2|height|gq2|:100}}]","thumbnail-size":"full","banner-columns":"5","margin-bottom":"0px"}}],"option":{"page-item-id":"","background-type":"color","background":"#f1f1f1","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"20px","padding-bottom":"10px"}}]',
					'post-option'=>'{"sidebar":"no-sidebar","left-sidebar":"Footer 1","right-sidebar":"Footer 1","page-style":"normal","show-title":"disable","page-caption":"","show-content":"enable","header-background":""}'
				),
				'about-2' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[]',
					'content-with-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"item","item-builder-title":"Title","type":"title","option":{"page-item-id":"","title-type":"center-icon-divider","title-size":"large","title":"About Limo King","caption":"We are the most popular limousine service in New York.","title-icon-class":"fa-star","right-text":"Read All News","right-text-link":"","margin-bottom":"20px"}}],"option":{"page-item-id":"","type":"image","background":"5814","background-mobile":"","background-speed":"0","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"limoking-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"150px","padding-bottom":"70px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Image / Frame","type":"image-frame","option":{"page-item-id":"","image-id":"5874","thumbnail-size":"full","link-type":"none","title":"","content":"","url":"","frame-type":"none","frame-background":"#dddddd","margin-bottom":"20px"}}],"option":{},"size":"1/2"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"About Us","type":"about-us","option":{"page-item-id":"","style":"with-caption","title":"Story About Us","caption":"Venenatis Fusce Vulputate","content":"<p>Limos King offers superb lim service in New York and Manhatatan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc. Donec id elit non mi porta gravida at eget metus. Cras justo odio, dapibus ac facilisis in, egestas eget quam. Aenean lacinia bibendum nulla sed consectetur. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus.</p>","read-more-type":"","read-more-text":"Read More","read-more-link":"","margin-bottom":"20px"}}],"option":{},"size":"1/2"}],"option":{"page-item-id":"","background-type":"color","background":"#f3f3f3","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"60px","padding-bottom":"24px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","size":"medium","image":"5876","icon":"","caption":"","title":"Night Parties","content":"<p>Limos King offers superb lim service in New York and Manhatatan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc.</p>","read-more-text":"Read More","read-more-link":"#","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","size":"medium","image":"5877","icon":"","caption":"","title":"Weddings","content":"<p>Limos King offers superb lim service in New York and Manhatatan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc.</p>","read-more-text":"Read More","read-more-link":"#","margin-bottom":"45px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","size":"medium","image":"5878","icon":"","caption":"","title":"Casinos","content":"<p>Limos King offers superb lim service in New York and Manhatatan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc.</p>","read-more-text":"Read More","read-more-link":"#","margin-bottom":"45px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","size":"medium","image":"5879","icon":"","caption":"","title":"Birthdays","content":"<p>Limos King offers superb lim service in New York and Manhatatan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc.</p>","read-more-text":"Read More","read-more-link":"#","margin-bottom":"45px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","size":"medium","image":"5880","icon":"","caption":"","title":"Proms","content":"<p>Limos King offers superb lim service in New York and Manhatatan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc.</p>","read-more-text":"Read More","read-more-link":"#","margin-bottom":"45px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","size":"medium","image":"5881","icon":"","caption":"","title":"Airport Transfers","content":"<p>Limos King offers superb lim service in New York and Manhatatan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc.</p>","read-more-text":"Read More","read-more-link":"#","margin-bottom":"45px"}}],"option":{},"size":"1/3"}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"60px","padding-bottom":"10px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-4","items":[{"item-type":"item","item-builder-title":"Skill Item","type":"skill-item","option":{"page-item-id":"","style":"style-1","icon-color":"#ffffff","title-color":"#ffffff","caption-color":"#ffffff","icon-class":"","title":"9000","caption":"HAPPY CUSTOMERS","margin-bottom":"20px"}}],"option":{},"size":"1/4"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-4","items":[{"item-type":"item","item-builder-title":"Skill Item","type":"skill-item","option":{"page-item-id":"","style":"style-1","icon-color":"#ffffff","title-color":"#ffffff","caption-color":"#ffffff","icon-class":"","title":"12","caption":"LUXURY LIMOS","margin-bottom":"20px"}}],"option":{},"size":"1/4"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-4","items":[{"item-type":"item","item-builder-title":"Skill Item","type":"skill-item","option":{"page-item-id":"","style":"style-1","icon-color":"#ffffff","title-color":"#ffffff","caption-color":"#ffffff","icon-class":"","title":"900000","caption":"MILES","margin-bottom":"20px"}}],"option":{},"size":"1/4"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-4","items":[{"item-type":"item","item-builder-title":"Skill Item","type":"skill-item","option":{"page-item-id":"","style":"style-1","icon-color":"#ffffff","title-color":"#ffffff","caption-color":"#ffffff","icon-class":"","title":"30","caption":"QUALIFIED CHAUFFUERS","margin-bottom":"20px"}}],"option":{},"size":"1/4"}],"option":{"page-item-id":"","type":"image","background":"5821","background-mobile":"","background-speed":"0.1","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"limoking-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"95px","padding-bottom":"65px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title-size":"medium","title":"","caption":"","title-icon-class":"","right-text":"Read All News","right-text-link":"","content":"","margin-bottom":"7px"}},{"item-type":"item","item-builder-title":"Skill Bar","type":"skill-bar","option":{"page-item-id":"","content":"New Cars","percent":"90","size":"small","icon":"","text-color":"#444444","background-color":"#e9e9e9","progress-color":"#1eacc7","margin-bottom":"22px"}},{"item-type":"item","item-builder-title":"Skill Bar","type":"skill-bar","option":{"page-item-id":"","content":"In-house Chauffuers","percent":"100","size":"small","icon":"","text-color":"#444444","background-color":"#e9e9e9","progress-color":"#1eacc7","margin-bottom":"22px"}},{"item-type":"item","item-builder-title":"Skill Bar","type":"skill-bar","option":{"page-item-id":"","content":"Satisfaction Rate","percent":"95","size":"small","icon":"","text-color":"#444444","background-color":"#e9e9e9","progress-color":"#1eacc7","margin-bottom":"22px"}},{"item-type":"item","item-builder-title":"Skill Bar","type":"skill-bar","option":{"page-item-id":"","content":"Willing To Come Back","percent":"100","size":"small","icon":"","text-color":"#444444","background-color":"#e9e9e9","progress-color":"#1eacc7","margin-bottom":"22px"}}],"option":{},"size":"1/2"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"About Us","type":"about-us","option":{"page-item-id":"","style":"plain","title":"Ullamcorper Parturient","caption":"","content":"<p>Limos King offers superb lim service in New York and Manhatatan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc. Donec id elit non mi porta gravida at eget metus. Cras justo odio, dapibus ac facilisis in, egestas eget quam. Aenean lacinia bibendum nulla sed consectetur. Curabitur blandit tempus porttitor. Donec id elit non mi porta gravida at eget metus. Duis mollis, est non commodo luctus, nisi erat porttitor ligula, eget lacinia odio.</p>","read-more-type":"","read-more-text":"Read More","read-more-link":"","margin-bottom":"20px"}}],"option":{},"size":"1/2"}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"55px","padding-bottom":"40px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Stunning Text","type":"stunning-text","option":{"page-item-id":"","title":"What about pricing?","caption":"Don’t worry. We provide very nice deals and the most competative price just for you!","read-more-type":"url","button-text":"Check Rates","button-link":"http://demo.goodlayers.com/limoking/service-rates/","button-text-color":"#fff","button-background":"#009fbd","margin-bottom":"0"}}],"option":{"page-item-id":"","background-type":"color","background":"#1eacc7","skin":"limoking-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"0px","padding-bottom":"0px"}}]',
					'post-option'=>'{"sidebar":"no-sidebar","left-sidebar":"Footer 1","right-sidebar":"Footer 1","page-style":"normal","show-title":"disable","page-caption":"","show-content":"enable","header-background":""}'
				),
				'service-1' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[]',
					'content-with-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"item","item-builder-title":"Title","type":"title","option":{"page-item-id":"","title-type":"center-icon-divider","title-size":"large","title":"Our Services","caption":"We are the most popular limousine service in New York.","title-icon-class":"fa-star","right-text":"Read All News","right-text-link":"","margin-bottom":"20px"}}],"option":{"page-item-id":"","type":"image","background":"5814","background-mobile":"","background-speed":"0","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"limoking-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"170px","padding-bottom":"90px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","size":"medium","image":"5876","icon":"","caption":"","title":"Night Parties","content":"<p>Limos King offers superb lim service in New York and Manhattan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms or any wherever you need us to take you. With our services, we can ensure you to enjoy the whole spectacular ride.</p>","read-more-text":"Read More","read-more-link":"#","margin-bottom":"20px"}}],"option":{},"size":"1/2"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","size":"medium","image":"5877","icon":"","caption":"","title":"Weddings","content":"<p>Limos King offers superb lim service in New York and Manhattan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms or any wherever you need us to take you. With our services, we can ensure you to enjoy the whole spectacular ride.</p>","read-more-text":"Read More","read-more-link":"#","margin-bottom":"45px"}}],"option":{},"size":"1/2"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","size":"medium","image":"5878","icon":"","caption":"","title":"Casinos","content":"<p>Limos King offers superb lim service in New York and Manhattan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms or any wherever you need us to take you. With our services, we can ensure you to enjoy the whole spectacular ride.</p>","read-more-text":"Read More","read-more-link":"#","margin-bottom":"45px"}}],"option":{},"size":"1/2"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","size":"medium","image":"5879","icon":"","caption":"","title":"Birthdays","content":"<p>Limos King offers superb lim service in New York and Manhattan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms or any wherever you need us to take you. With our services, we can ensure you to enjoy the whole spectacular ride.</p>","read-more-text":"Read More","read-more-link":"#","margin-bottom":"45px"}}],"option":{},"size":"1/2"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","size":"medium","image":"5880","icon":"","caption":"","title":"Proms","content":"<p>Limos King offers superb lim service in New York and Manhattan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms or any wherever you need us to take you. With our services, we can ensure you to enjoy the whole spectacular ride.</p>","read-more-text":"Read More","read-more-link":"#","margin-bottom":"45px"}}],"option":{},"size":"1/2"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"image","size":"medium","image":"5881","icon":"","caption":"","title":"Airport Transfers","content":"<p>Limos King offers superb lim service in New York and Manhattan.  We are the most popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms or any wherever you need us to take you. With our services, we can ensure you to enjoy the whole spectacular ride.</p>","read-more-text":"Read More","read-more-link":"#","margin-bottom":"45px"}}],"option":{},"size":"1/2"}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"60px","padding-bottom":"10px"}},{"item-type":"wrapper","item-builder-title":"Full Size Wrapper","type":"full-size-wrapper","items":[{"item-type":"item","item-builder-title":"Master Slider","type":"master-slider","option":{"page-item-id":"","id":"2","margin-bottom":"0px"}}],"option":{"page-item-id":"","skin":"no-skin","background":"#ffffff","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"0px","padding-bottom":"0px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"no-media","size":"medium","image":"","icon":"","caption":"Venenatis Fusce Vulputate","title":"Fermentum Risus Venenatis","content":"<p>Limos King offers superb lim service in New York and Manhatatan.  We are tmost popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc. Donec id elit non mi porta gravida at eget metus. Cras justo odio, dapibus ac.</p>","read-more-text":"Read More","read-more-link":"","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"no-media","size":"medium","image":"","icon":"","caption":"Justo Consectetur Fermentum","title":"Cursus Euismod Tortor","content":"<p>Limos King offers superb lim service in New York and Manhatatan.  We are tmost popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc. Donec id elit non mi porta gravida at eget metus. Cras justo odio, dapibus ac.</p>","read-more-text":"Read More","read-more-link":"","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Column Service","type":"column-service","option":{"page-item-id":"","type":"no-media","size":"medium","image":"","icon":"","caption":"Purus Mollis Ornare","title":"Dolor Fusce Fringilla","content":"<p>Limos King offers superb lim service in New York and Manhatatan.  We are tmost popular and has been chosen by many important people. We also provide premier service to the airport, wedding, casino, sport event, proms etc. Donec id elit non mi porta gravida at eget metus. Cras justo odio, dapibus ac.</p>","read-more-text":"Read More","read-more-link":"","margin-bottom":"20px"}}],"option":{},"size":"1/3"}],"option":{"page-item-id":"","background-type":"color","background":"#ffffff","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"55px","padding-bottom":"15px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"About Us","type":"about-us","option":{"page-item-id":"","style":"with-divider","title":"Only Qualified Chauffeurs","caption":"","content":"<p>Sed posuere consectetur est at lobortis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nullam quis risus eget urna mollis ornare vel eu leo. Cras mattis consectetur purus sit amet fermentum.</p>","read-more-type":"car-form","read-more-text":"Book Now","read-more-link":"http://demo.goodlayers.com/limoking/service-rates/","margin-bottom":"20px"}}],"option":{},"size":"3/5"}],"option":{"page-item-id":"","type":"image","background":"5824","background-mobile":"","background-speed":"0","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"limoking-skin-about-us","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"100px","padding-bottom":"60px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Stunning Text","type":"stunning-text","option":{"page-item-id":"","title":"What about pricing?","caption":"Don’t worry. We provide very nice deals and the most competative price just for you!","read-more-type":"url","button-text":"Check Rates","button-link":"http://demo.goodlayers.com/limoking/service-rates/","button-text-color":"#fff","button-background":"#009fbd","margin-bottom":"0"}}],"option":{"page-item-id":"","background-type":"color","background":"#1eacc7","skin":"limoking-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"0px","padding-bottom":"0px"}}]',
					'post-option'=>'{"sidebar":"no-sidebar","left-sidebar":"Footer 1","right-sidebar":"Footer 1","page-style":"normal","show-title":"disable","page-caption":"","show-content":"enable","header-background":""}'
				),
				'contact-1' => array(
					'above-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Full Size Wrapper","type":"full-size-wrapper","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title-size":"small","title":"","caption":"","title-icon-class":"","right-text":"Read All News","right-text-link":"","content":"<p>[put_wpgm id=1]</p>","margin-bottom":"0px"}}],"option":{"page-item-id":"","skin":"","background":"#ffffff","show-section":"gdlr-show-all","border":"none","border-top-color":"#dddddd","border-bottom-color":"#dddddd","padding-top":"0px","padding-bottom":"0px"}}]',
					'below-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Box Icon","type":"box-icon-item","option":{"page-item-id":"","icon":"fa-envelope","icon-position":"top","icon-type":"circle","icon-color":"#ffffff","icon-background":"#36bddb","title":"Contact By Email","content":"<p>Lorem ipsum dolor sit amet, consectetur adipisici elit, sed eiusmod tempor incidunt ut labore et dolore magna aliqua.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"Box Icon","type":"box-icon-item","option":{"page-item-id":"","icon":"fa-phone","icon-position":"top","icon-type":"circle","icon-color":"#ffffff","icon-background":"#36bddb","title":"Contact By Phone","content":"<p>Lorem ipsum dolor sit amet, consectetur adipisici elit, sed eiusmod tempor incidunt ut labore et dolore magna aliqua.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-3","items":[{"item-type":"item","item-builder-title":"Box Icon","type":"box-icon-item","option":{"page-item-id":"","icon":"fa-home","icon-position":"top","icon-type":"circle","icon-color":"#ffffff","icon-background":"#36bddb","title":"Come To See Us","content":"<p>Lorem ipsum dolor sit amet, consectetur adipisici elit, sed eiusmod tempor incidunt ut labore et dolore magna aliqua.</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"}],"option":{"page-item-id":"","type":"image","background":"5918","background-mobile":"","background-speed":"0.2","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"no-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#dddddd","border-bottom-color":"#dddddd","padding-top":"100px","padding-bottom":"50px"}}]',
					'content-with-sidebar'=>'[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title-size":"small","title":"","caption":"","title-icon-class":"","right-text":"Read All News","right-text-link":"","content":"<p>[gdlr_space height=|gq2|-22px|gq2|] [gdlr_heading tag=|gq2|h5|gq2| font_weight=|gq2|bold|gq2| ]Please fulfil the form below. [/gdlr_heading] [gdlr_space height=|gq2|25px|gq2|] [contact-form-7 id=|gq2|5|gq2| title=|gq2|Contact form 1|gq2|]</p>","margin-bottom":"60px"}}]',
					'post-option'=>'{"sidebar":"right-sidebar","left-sidebar":"Footer 1","right-sidebar":"contact","page-style":"normal","show-title":"disable","page-caption":"","show-content":"enable","header-background":""}'
				),
				'contact-2' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Full Size Wrapper","type":"full-size-wrapper","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title-size":"","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"<p>[put_wpgm id=1]</p>","margin-bottom":"0px"}}],"option":{"page-item-id":"","background":"#ffffff","show-section":"gdlr-show-all","border":"none","border-top-color":"#d8d8d8","border-bottom-color":"#dddddd","padding-top":"0px","padding-bottom":"0px"}}]',
					'content-with-sidebar'=>'[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"none","title-size":"small","title":"","caption":"","right-text":"Read All News","right-text-link":"","content":"<p>[gdlr_space height=|gq2|-22px|gq2|] [gdlr_heading tag=|gq2|h5|gq2| font_weight=|gq2|bold|gq2| ]Please fulfil the form below.[/gdlr_heading] [gdlr_space height=|gq2|25px|gq2|] [contact-form-7 id=|gq2|5|gq2| title=|gq2|Contact form 1|gq2|]</p>","margin-bottom":"60px"}}]',
					'post-option'=>'{"sidebar":"left-sidebar","left-sidebar":"contact","right-sidebar":"contact","page-style":"normal","show-title":"enable","page-caption":"Aenean eu leo quam. Pellentesque ornare sem.","show-content":"enable","header-background":"","header-style":"default"}'
				),
				'faq' => array(
					'above-sidebar'=>'[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-5","items":[{"item-type":"item","item-builder-title":"Accordion","type":"accordion","option":{"page-item-id":"","accordion":"[{|gq2|gdl-tab-title|gq2|:|gq2|Bibendum Porta Fermentum?|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Donec sed odio dui. Maecenas sed diam eget risus varius blandit sit amet non magna. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Donec id elit non mi porta gravida at eget metus. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum.|g2n||g2n|<ul>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|<li>Etiam porta sem malesuada magna mollis euismod.</li>|g2n|<li>Aenean lacinia bibendum nulla sed consectetur.</li>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|</ul>|g2n||g2n|Etiam porta sem malesuada magna mollis euismod. Cras mattis consectetur purus sit amet fermentum. Donec sed odio dui. Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|Nullam quis risus eget urna mollis ornare vel eu leo. Nulla vitae elit libero, a pharetra augue. Sed posuere consectetur est at lobortis. Curabitur blandit tempus porttitor. Maecenas sed diam eget risus varius blandit sit amet non magna. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|[gdlr_button href=|gq6|http://themeforest.net/user/GoodLayers|gq6| target=|gq6|_self|gq6| size=|gq6|medium|gq6| background=|gq6|#1eacc7|gq6| color=|gq6|#ffffff|gq6|]Learn More[/gdlr_button]|gq2|},{|gq2|gdl-tab-title|gq2|:|gq2|Quam Elit Malesuada Magna?|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Donec sed odio dui. Maecenas sed diam eget risus varius blandit sit amet non magna. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Donec id elit non mi porta gravida at eget metus. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum.|g2n||g2n|<ul>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|<li>Etiam porta sem malesuada magna mollis euismod.</li>|g2n|<li>Aenean lacinia bibendum nulla sed consectetur.</li>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|</ul>|g2n||g2n|Etiam porta sem malesuada magna mollis euismod. Cras mattis consectetur purus sit amet fermentum. Donec sed odio dui. Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|Nullam quis risus eget urna mollis ornare vel eu leo. Nulla vitae elit libero, a pharetra augue. Sed posuere consectetur est at lobortis. Curabitur blandit tempus porttitor. Maecenas sed diam eget risus varius blandit sit amet non magna. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|[gdlr_button href=|gq6|http://themeforest.net/user/GoodLayers|gq6| target=|gq6|_self|gq6| size=|gq6|medium|gq6| background=|gq6|#1eacc7|gq6| color=|gq6|#ffffff|gq6|]Learn More[/gdlr_button]|gq2|},{|gq2|gdl-tab-title|gq2|:|gq2|Praesent commodo cursus magna, vel scelerisque nisl consectetur et?|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Donec sed odio dui. Maecenas sed diam eget risus varius blandit sit amet non magna. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Donec id elit non mi porta gravida at eget metus. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum.|g2n||g2n|<ul>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|<li>Etiam porta sem malesuada magna mollis euismod.</li>|g2n|<li>Aenean lacinia bibendum nulla sed consectetur.</li>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|</ul>|g2n||g2n|Etiam porta sem malesuada magna mollis euismod. Cras mattis consectetur purus sit amet fermentum. Donec sed odio dui. Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|Nullam quis risus eget urna mollis ornare vel eu leo. Nulla vitae elit libero, a pharetra augue. Sed posuere consectetur est at lobortis. Curabitur blandit tempus porttitor. Maecenas sed diam eget risus varius blandit sit amet non magna. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|[gdlr_button href=|gq6|http://themeforest.net/user/GoodLayers|gq6| target=|gq6|_self|gq6| size=|gq6|medium|gq6| background=|gq6|#1eacc7|gq6| color=|gq6|#ffffff|gq6|]Learn More[/gdlr_button]|gq2|},{|gq2|gdl-tab-title|gq2|:|gq2|Sem Purus Bibendum Pharetra?|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Donec sed odio dui. Maecenas sed diam eget risus varius blandit sit amet non magna. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Donec id elit non mi porta gravida at eget metus. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum.|g2n||g2n|<ul>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|<li>Etiam porta sem malesuada magna mollis euismod.</li>|g2n|<li>Aenean lacinia bibendum nulla sed consectetur.</li>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|</ul>|g2n||g2n|Etiam porta sem malesuada magna mollis euismod. Cras mattis consectetur purus sit amet fermentum. Donec sed odio dui. Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|Nullam quis risus eget urna mollis ornare vel eu leo. Nulla vitae elit libero, a pharetra augue. Sed posuere consectetur est at lobortis. Curabitur blandit tempus porttitor. Maecenas sed diam eget risus varius blandit sit amet non magna. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|[gdlr_button href=|gq6|http://themeforest.net/user/GoodLayers|gq6| target=|gq6|_self|gq6| size=|gq6|medium|gq6| background=|gq6|#1eacc7|gq6| color=|gq6|#ffffff|gq6|]Learn More[/gdlr_button]|gq2|},{|gq2|gdl-tab-title|gq2|:|gq2|Praesent commodo cursus magna, vel scelerisque nisl consectetur et?|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Donec sed odio dui. Maecenas sed diam eget risus varius blandit sit amet non magna. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Donec id elit non mi porta gravida at eget metus. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum.|g2n||g2n|<ul>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|<li>Etiam porta sem malesuada magna mollis euismod.</li>|g2n|<li>Aenean lacinia bibendum nulla sed consectetur.</li>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|</ul>|g2n||g2n|Etiam porta sem malesuada magna mollis euismod. Cras mattis consectetur purus sit amet fermentum. Donec sed odio dui. Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|Nullam quis risus eget urna mollis ornare vel eu leo. Nulla vitae elit libero, a pharetra augue. Sed posuere consectetur est at lobortis. Curabitur blandit tempus porttitor. Maecenas sed diam eget risus varius blandit sit amet non magna. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|[gdlr_button href=|gq6|http://themeforest.net/user/GoodLayers|gq6| target=|gq6|_self|gq6| size=|gq6|medium|gq6| background=|gq6|#1eacc7|gq6| color=|gq6|#ffffff|gq6|]Learn More[/gdlr_button]|gq2|},{|gq2|gdl-tab-title|gq2|:|gq2|Sollicitudin Fermentum Risus Commodo Nibh?|gq2|,|gq2|gdl-tab-content|gq2|:|gq2|Donec sed odio dui. Maecenas sed diam eget risus varius blandit sit amet non magna. Fusce dapibus, tellus ac cursus commodo, tortor mauris condimentum nibh, ut fermentum massa justo sit amet risus. Donec id elit non mi porta gravida at eget metus. Aenean eu leo quam. Pellentesque ornare sem lacinia quam venenatis vestibulum.|g2n||g2n|<ul>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|<li>Etiam porta sem malesuada magna mollis euismod.</li>|g2n|<li>Aenean lacinia bibendum nulla sed consectetur.</li>|g2n|<li>Cras justo odio, dapibus ac facilisis in, egestas eget quam.</li>|g2n|</ul>|g2n||g2n|Etiam porta sem malesuada magna mollis euismod. Cras mattis consectetur purus sit amet fermentum. Donec sed odio dui. Curabitur blandit tempus porttitor. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|Nullam quis risus eget urna mollis ornare vel eu leo. Nulla vitae elit libero, a pharetra augue. Sed posuere consectetur est at lobortis. Curabitur blandit tempus porttitor. Maecenas sed diam eget risus varius blandit sit amet non magna. Nullam quis risus eget urna mollis ornare vel eu leo.|g2n||g2n|[gdlr_button href=|gq6|http://themeforest.net/user/GoodLayers|gq6| target=|gq6|_self|gq6| size=|gq6|medium|gq6| background=|gq6|#1eacc7|gq6| color=|gq6|#ffffff|gq6|]Learn More[/gdlr_button]|gq2|}]","title-type":"none","title-size":"small","title":"","caption":"","title-icon-class":"","initial-state":"1","style":"style-1","margin-bottom":"60px"}}],"option":{},"size":"2/3"},{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-5","items":[{"item-type":"item","item-builder-title":"Content","type":"content","option":{"page-item-id":"","title-type":"left","title-size":"small","title":"Can\'t find answer? Ask Us.","caption":"","title-icon-class":"","right-text":"Read All News","right-text-link":"","content":"<p>[contact-form-7 id=|gq2|5|gq2| title=|gq2|Contact Homepage|gq2|]</p>","margin-bottom":"20px"}}],"option":{},"size":"1/3"}]',
					'below-sidebar'=>'[]',
					'content-with-sidebar'=>'[]',
					'post-option'=>'{"sidebar":"no-sidebar","left-sidebar":"Footer 1","right-sidebar":"Footer 1","page-style":"normal","show-title":"enable","page-caption":"","show-content":"enable","header-background":""}'
				),
				'service-rates' => array(
					'above-sidebar'=>'[]',
					'below-sidebar'=>'[]',
					'content-with-sidebar'=>'[{"item-type":"item","item-builder-title":"Car Rate Table","type":"car-rate","option":{"page-item-id":"","category":"","feature-rate":"hour-rate","num-fetch":"9","thumbnail-size":"full","orderby":"date","order":"desc","margin-bottom":"0px"}},{"item-type":"wrapper","item-builder-title":"Color Wrapper","type":"color-wrapper","items":[{"item-type":"item","item-builder-title":"Stunning Text","type":"stunning-text","option":{"page-item-id":"","title":"Need other options?","caption":"No worry, just call us (1)-212-333-4343 or book online so we can discuss more about it.","read-more-type":"car-form","button-text":"Book Now","button-link":"","button-text-color":"#fff","button-background":"#009fbd","margin-bottom":"0"}}],"option":{"page-item-id":"","background-type":"color","background":"#1eacc7","skin":"limoking-skin-dark-skin","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"0px","padding-bottom":"0px"}},{"item-type":"wrapper","item-builder-title":"Background/Parallax Wrapper","type":"parallax-bg-wrapper","items":[{"item-type":"wrapper","item-builder-title":"Column Item","type":"column1-2","items":[{"item-type":"item","item-builder-title":"About Us","type":"about-us","option":{"page-item-id":"","style":"with-divider","title":"We promise, you will have  the best experience","caption":"","content":"<p>Sed posuere consectetur est at lobortis. Cum sociis natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Nullam quis risus eget urna mollis ornare vel eu leo. Cras mattis consectetur purus sit amet fermentum.</p>","read-more-type":"car-form","read-more-text":"Book Now","read-more-link":"","margin-bottom":"20px"}}],"option":{},"size":"1/2"}],"option":{"page-item-id":"","type":"image","background":"5768","background-mobile":"","background-speed":"0","pattern":"1","video":"","video-overlay":"0.5","video-player":"enable","skin":"limoking-skin-darkblue","show-section":"gdlr-show-all","border":"none","border-top-color":"#e9e9e9","border-bottom-color":"#e9e9e9","padding-top":"90px","padding-bottom":"60px"}}]',
					'post-option'=>'{"sidebar":"no-sidebar","left-sidebar":"Footer 1","right-sidebar":"Footer 1","page-style":"normal","show-title":"enable","page-caption":"","show-content":"enable","header-background":""}'
				),				
			);

			$loaded_data = $default_data[$_POST['slug']];
			foreach( $loaded_data as $meta_key => $meta_value ){
				update_post_meta($_POST['post_id'], $meta_key, $meta_value);
			}
		}
	}
?>